.386P
; .
.MODEL FLAT, STDCALL
include pr21_1.asm
;    .
includelib c:\masm32\lib\user32.lib 
includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\gdi32.lib
;------------------------------------------------
; . 
_DATA SEGMENT DWORD PUBLIC USE32 'DATA'
     NEWHWND     DD 0
     MSG         MSGSTRUCT <?>
     WC          WNDCLASS <?>
     PNT         PAINTSTR <?>
     SZT         SIZET <?>
     RCT         RECT <?>
     lg          LOGFONT <?>
     HINST       DD 0 ;   .
     TITLENAME   DB '  ',0
     NAM         DB 'CLASS32',0
     NFONT              DB  'Arial Cyr',0
     XT          DWORD ?
     YT          DWORD ?
     TEXT        DB '  ',0
     CONT        DWORD ?
_DATA ENDS 
; .
_TEXT SEGMENT DWORD PUBLIC USE32 'CODE'
START: 
;  .
     PUSH  0
     CALL  GetModuleHandleA@4
     MOV   [HINST], EAX
REG_CLASS:
;  .
;.
     MOV [WC.CLSSTYLE],stylcl 
;  .
     MOV   [WC.CLWNDPROC], OFFSET WNDPROC
     MOV   [WC.CLSCBCLSEX], 0
     MOV   [WC.CLSCBWNDEX], 0
     MOV   EAX, [HINST]
     MOV   [WC.CLSHINST], EAX
 
;------------  
    PUSH   IDI_APPLICATION
    PUSH   0
    CALL   LoadIconA@8
    MOV    [WC.CLSHICON], EAX
;------------  
    PUSH   IDC_CROSS
    PUSH   0
    CALL   LoadCursorA@8
    MOV    [WC.CLSHCURSOR], EAX
;------------
    PUSH   RGBW ; .
    CALL   CreateSolidBrush@4; .
    MOV    [WC.CLBKGROUND],EAX 
    MOV    DWORD PTR [WC.CLMENNAME],0
    MOV    DWORD PTR [WC.CLNAME], OFFSET  NAM
    PUSH   OFFSET WC
    CALL   RegisterClassA@4
;   .
    PUSH   0
    PUSH   [HINST]
    PUSH   0
    PUSH   0
    PUSH   DY0      ; DY0 -  .
    PUSH   DX0      ; DX0 -  .
    PUSH   100      ;  Y.
    PUSH   100      ;  X.
    PUSH   WS_OVERLAPPEDWINDOW
    PUSH   OFFSET TITLENAME  ; .
    PUSH   OFFSET NAM        ; .
    PUSH   0
    CALL   CreateWindowExA@48
;  .
    CMP    EAX,0
    JZ    _ERR
    MOV   [NEWHWND], EAX  ; .
;------------------------------------
    PUSH  SW_SHOWNORMAL
    PUSH  [NEWHWND]
    CALL  ShowWindow@8    ;  .
;------------------------------------
    PUSH  [NEWHWND]
    CALL UpdateWindow@4   ;  
                          ; ,  WM_PAINT.
;   
MSG_LOOP:
    PUSH 0
    PUSH 0
    PUSH 0
    PUSH OFFSET MSG
    CALL GetMessageA@16
    CMP  EAX, 0
    JE   END_LOOP
    PUSH OFFSET MSG
    CALL TranslateMessage@4
    PUSH OFFSET MSG
    CALL DispatchMessageA@4
    JMP  MSG_LOOP 
END_LOOP: 
;   ( ).
    PUSH [MSG.MSWPARAM]
    CALL ExitProcess@4
_ERR:
    JMP  END_LOOP
;-----------------------------------------
; .
;   : 
;[+14] LPARAM 
;[+10] WPARAM 
;[+0] MES 
;[+08H] HWND 
WNDPROC PROC
        PUSH EBP
        MOV  EBP, ESP
        PUSH EBX
        PUSH ESI
        PUSH EDI
        CMP  DWORD PTR [EBP+0CH], WM_DESTROY
        JE   WMDESTROY
        CMP  DWORD PTR [EBP+0CH], WM_CREATE
        JE   WMCREATE
        CMP  DWORD PTR [EBP+0CH], WM_PAINT
        JE   WMPAINT
        JMP  DEFWNDPROC
WMPAINT:
;--------------------------
        PUSH OFFSET PNT
        PUSH DWORD PTR [EBP+08H]
        CALL BeginPaint@8
        MOV  CONT,EAX ;  ()
;------------------------   =  
        PUSH RGBW
        PUSH EAX
        CALL SetBkColor@8
;------------------------   ()
        PUSH RGBT
        PUSH CONT
        CALL SetTextColor@8
;  .
        MOV  XT,120
        MOV  YT,140
; () .
        MOV  lg.LfHeight,12      ; .
        MOV  lg.LfWidth,9        ; .
        MOV  lg.LfEscapement,900 ; -
        MOV  lg.LfOrientation,0  ;.
        MOV  lg.LfWeight,400     ;  .
        MOV  lg.LfItalic,0       ;
        MOV  lg.LfUnderline,0    ;.
        MOV  lg.LfStrikeOut,0    ;.
        MOV  lg.LfCharSet,0      ; .
        MOV  lg.LfOutPrecision,0
        MOV  lg.LfClipPrecision,0
        MOV  lg.LfQuality,2
        MOV  lg.LfPitchAndFamily,0
        PUSH OFFSET lg 
;  .
        PUSH OFFSET NFONT
        PUSH OFFSET lg.LfFaceName
        CALL COPYSTR
        CALL CreateFontIndirectA@4
;--------------------   
        PUSH EAX
        PUSH CONT
        CALL SelectObject@8
        PUSH EAX
;--------------------      
        PUSH OFFSET TEXT 
        CALL LENSTR
;--------------------    	
        PUSH EBX
        PUSH OFFSET TEXT 
        PUSH YT 
        PUSH XT 
        PUSH CONT 
        CALL TextOutA@20 
;   "FONT". 
;   . 
        CALL DeleteObject@4
;--------------------  
        PUSH OFFSET  PNT
        PUSH DWORD  PTR   [EBP+08H]
        CALL EndPaint@8
        MOV EAX, 0
        JNP FINISH
WMCREATE:
        MOV EAX, 0 
        JMP FINISH 
DEFWNDPROC:
        PUSH DWORD PTR [EBP+14H]
        PUSH DWORD PTR [EBP+10H]
        PUSH DWORD PTR [EBP+0CH]
        PUSH DWORD PTR [EBP+08H]
        CALL DefWindowProcA@16
        JMP  FINISH
WMDESTROY:	
        PUSH 0                   ;MB_OK
        CALL PostQuitMessage@4   ; WM_QUIT.
        MOV  EAX, 0
FINISH:	
        POP  EDI
        POP  ESI
        POP  EBX
        POP  EBP
        RET  16
WNDPROC ENDP
;----------------  -----------------------
; , [+08] -   .
LENSTR  PROC
        PUSH EBP
        MOV  EBP,ESP
        PUSH ESI
        MOV  ESI,DWORD PTR [EBP+8]
        XOR  EBX,EBX
LBL1:
        CMP  BYTE PTR [ESI],0 
        JZ   LBL2 
        INC  EBX 
        INC  ESI 
        JMP  LBL1
LBL2:
        POP  ESI
        POP  EBP
        RET  4
LENSTR  ENDP 
;     .
;,      [+08].
;,       [+0]. 
COPYSTR PROC
        PUSH EBP
        MOV EBP,ESP
        MOV ESI,DWORD PTR [EBP+0CH]
        MOV EDI,DWORD PTR [EBP+08H]
L1:
        MOV AL, BYTE PTR [ESI]
        MOV BYTE PTR [EDI], AL
        CMP AL,0
        JE L2
        INC ESI
        INC EDI
        JMP L1
L2:	
        POP EBP
        RET 8
COPYSTR ENDP
_TEXT   ENDS 
        END START
